#ifndef _ALSA_SEQ_H_
#define _ALSA_SEQ_H_

namespace ALSA {

class SeqClient
: public Plugin
{
	public:
		snd_seq_t * handle;
		int client, port, q, direction;
		
	public:
		SeqClient();
		~SeqClient();
		
		void open (char * name, int _direction);
		void subscribe (int major, int minor, bool connect = true);

		/* //////////////////////////////////////////////// */

		void __init__ (PyObject * args, PyObject * kwds)
			{ throw NotImplementedError() + "you cannot instantiate this"; }

		PyObject * _subscribe (PyObject * args);
		PyObject * _unsubscribe (PyObject * args);
};

class SeqIn
: public SeqClient
{
	public:
		SeqIn();

		virtual void handle_io (int fd, IOCycle & c);

		/* //////////////////////////////////////////////// */

		void __init__ (PyObject * args, PyObject * kwds);
};

class SeqOut
: public SeqClient
{
	private:
		snd_seq_event_t packet;

	public:
		SeqOut();

		virtual void cycle (Cycle & c);
		void send_packet (Packet * p, int channel);
		void send_sysex (Packet * p);

		/* //////////////////////////////////////////////// */

		void __init__ (PyObject * args, PyObject * kwds);
};

}; /* namespace ALSA */

#endif /* _ALSA_SEQ_H_ */
