#ifndef _EVENT_LIST_H_
#define _EVENT_LIST_H_

#include "Event.h"
#include "List.h"
#include "Plugin.h"

class EventList
: public Plugin
{
	public:
		Mutex mutex;
		List<Event, 2000> events;
		
	public:
		EventList();
		~EventList();

		/* binary search for the first event at a tick, returns its index */
		int _index (Time::tick t)
			{
				int hi = events, lo = -1;

				while (hi - lo > 1)
				{
					int probe = (hi + lo) / 2;

					if (events[probe].t < t)
						lo = probe;
					else
						hi = probe;
				}

				return hi;
			}

		/* Plugin ////////////////////////////////////////////////////// */
		void cycle (Cycle &);

		/* /////////////////////////////////////////////////////////// */

		void __init__ (PyObject * args, PyObject * kwds);

		PyObject * add (PyObject * args, PyObject * kwds);
		PyObject * index (PyObject * args);

		/* sequence methods */
		int sq_length() { return events; }
		PyObject * sq_item (int i);
};

#endif /* _EVENT_LIST_H_ */
