#ifndef _MIDI_IN_H_
#define _MIDI_IN_H_

#include "Plugin.h"
#include "Plugin.h"

class MIDIIn
: public Plugin
{
	private:
		_Cycle * cycle; /* only valid during handle_io */
		List<byte, 2048> data; /* to hold sysex, grows if needed */
		Event event;
		
		/* flags for filtering MIDI realtime messages */
		int f8: 1;
		int fe: 1;

		int running; /* running status */
		int bytes; /* in the current message */
		int expect;
		enum {
			Data = 1,
			Status = 2,
		};

	public:
		MIDIIn();
		~MIDIIn();

		virtual void handle_io (int fd, IOCycle & c);

		void parse (byte b);
		void start_event (byte status);
		void dispatch();

		/* ////////////////////////////////////////////////////////// */

		void __init__ (PyObject * args, PyObject * kwds);

};

#endif /* _MIDI_IN_H_ */
