#include "basics.h"
#include "Mutex.h"

Mutex::Mutex()
{
	pthread_mutexattr_t attr;
	pthread_mutexattr_init (&attr);
	
	pthread_mutexattr_settype (&attr, PTHREAD_MUTEX_DEFAULT);
	pthread_mutex_init (&mutex, &attr);
}

Mutex::~Mutex()
{
	pthread_mutex_destroy (&mutex);
}

void
Mutex::lock()
{
	pthread_mutex_lock (&mutex);
}

bool
Mutex::trylock()
{
	if (pthread_mutex_trylock (&mutex) == EBUSY)
		return false;
	return true;
}

void
Mutex::unlock()
{
	pthread_mutex_unlock (&mutex);
}


