#ifndef _OBJECT_H_
#define _OBJECT_H_

#include <Python.h>

#define VISIT(x) { int e = visit (x, arg); if (e) return e; }
		
class Object
{
	public:
		static int live_objects;

		void * operator new (size_t size, void * self)
			{ return self; }

		Object()
			{ ++live_objects; }
		
		virtual ~Object()
			{ --live_objects; }
		
		/* requires this to be inside a Py<Object> */
		PyObject * as_py_object()
			{ return ((PyObject *) ((void *) this)) - 1; }

		void __init__ (PyObject * args, PyObject * kwds)
			{ throw NotImplementedError() + "You cannot instantiate this"; }

		int _traverse (visitproc visit, void * arg)
			{ return 0; }

		int _clear()
			{ return 0; }
};

inline void 
decref (PyObject * o)
{
	Py_DECREF (o);
}

inline void 
xdecref (PyObject * o)
{
	if (o) Py_DECREF (o);
}

inline PyObject *
incref (PyObject * o)
{
	Py_INCREF (o);
	return o;
}

#endif /* _OBJECT_H_ */
