#ifndef _PY_LOCK_H_
#define _PY_LOCK_H_

#include "Thread.h"

class PyLock
{
	public:
		PyThreadState * tstate;

		PyLock()
			{
				Thread * t = Thread::current();

				if (t == 0)
					throw AssertionError() + "thread unknown";
				if (t->tstate == 0)
					throw AssertionError() + "thread has no tstate";

				PyEval_AcquireLock();
				tstate = PyThreadState_Swap (t->tstate);
			}

		~PyLock()
			{
				PyThreadState_Swap (tstate);
				PyEval_ReleaseLock();
			}
};

class PyUnlock
{
	public:
		PyThreadState * tstate;

		PyUnlock()
			{
				tstate = PyThreadState_Swap (0);
				PyEval_ReleaseLock();
			}

		~PyUnlock()
			{
				PyEval_AcquireLock();
				PyThreadState_Swap (tstate);
			}
};

#endif /* _PY_LOCK_H_ */
