#include "basics.h"
#include "Plugin.h"

void
_Cycle::push (Packet * p, TX * tx)
{
	if (!tx->push (p))
		discard (p);	
}

Packet *
_Cycle::packet (PyObject * args)
{
	Packet * p = packet();
	if (p->parse (args))
		return p;
	
	discard (p);
	throw blewit();
}

Packet *
RX::get_audio (Cycle * c)
{
	while (fifo.have())
	{
		Packet * p = fifo.pop();
		if (p->type == Packet::Audio)
			return p;
		c->discard (p);
	}

	return 0;
}

#include "RXTX.thunk.h"
#if PYTHUNK
	Class (RX, Object)
	Get (RX :: name)
	
	Class (TX, Object)
	Get (TX :: name)
	
	Class (RXList, Object)
	sq_length (RXList)
	sq_item (RXList)
	
	Class (TXList, Object)
	sq_length (TXList)
	sq_item (TXList)
#endif

void 
init_RXTX (PyObject * dict)
{
	new PyType<RX> ("RX", dict);
	new PyType<TX> ("TX", dict);
	new PyType<RXList> ("RXList", dict);
	new PyType<TXList> ("TXList", dict);
}
