#ifndef _msg_h_
#define _msg_h_

#include <stdio.h>

class Event;
class Packet;

class message
{
	public:
		static void init (char * path);
		static void fini();

		static FILE * f;
		static PyObject * file;

	public:
		message();

		~message()
			{
				fputc ('\n', f);
				fflush (f);
			}

		message & operator , (PyObject * o)
			{
				if (o == 0)
					fputs ("<PyObject at 0>", f);
				else
					fprintf (f, "<%s at %p>", o->ob_type->tp_name, o);
				return *this;
			}

		message & operator , (void * p)
			{
				fprintf (f, "<%p>", p);
				return *this;
			}

		message & operator , (const char * s)
			{
				fputs (s, f);
				return *this;
			}

		message & operator , (byte b)
			{
				fprintf (f, "%02x", b);
				return *this;
			}

		message & operator , (int i)
			{
				fprintf (f, "%d", i);
				return *this;
			}

		message & operator , (double d)
			{
				fprintf (f, "%.3f", d);
				return *this;
			}

		message & operator , (Event * e);
		message & operator , (Packet * p);
		
		message & py_err();
		message & bytes (byte * b, int n)
			{
				for (int i = 0; i < n; ++i)
					fprintf (f, "%02x ", b[i]);
				return *this;
			}
};

#define msg() message(), __FILE__, ":", __LINE__, " "

#endif /* _msg_h_ */
